	; simple harddisk lister, public domain
	; assemble with NASM into a COM file
	org 0x100

start:	mov dx,0x80
cnt:	call dtest
	inc dx
	cmp dl,0x87
	jbe cnt

	mov dx,txt	; message
	mov ah,9	; show string
	int 0x21
	mov ax,0x4c00	; exit with errorlevel 0
	mov al,[elevel]	; update errorlevel to drive count
	int 0x21

dtest:			; test if drive DL exists. Preserves DX.
	mov ah,8	; get GEOMETRY
	push es		; ES:DI only modified for floppy (pointer to DDPT)
	push di		; also modified: DH:CX geometry, BL type, AX undef
	push dx		; DL number-of-drives
	int 0x13
	mov ax,dx	; returned DL + 0x80 must be more than caller DL,
	pop dx		; otherwise the report might be for a ghost drive.
	pop di		; 40:75 can be better than the returned DL...
	pop es
	jc nodrv
	add al,0x80	; returned DL + 0x80 ...
	cmp al,dl
	jbe nodrv

yesdrv:	push cx
	push dx
	mov ax,0x1500	; get disk TYPE
	int 0x13
	pop dx		; returns: AH type: 0 none, 1 oldfloppy,
	pop cx		; 2 floppywithchangeline, 3 harddisk
	jc nodrv	; (in latter case: of size CX:DX sectors)
	or ah,ah	; or "cmp ah,3" to make sure to match only HDD
	jz nodrv

	inc byte [elevel]

	mov ax,0x4100	; test for LBA
	mov bx,0x55aa
	int 0x13	; if not supported: bx unchanged, AH=1, carry
	cmp bx,0xaa55	; confirmed? modified: BX (magic)
	jnz nolba	; AH:DH (version) AL (undef) CX (flags)
	test cx,1	; test 1 for LBA, 2 for removable, 4 for EDD
	jz nolba

yeslba:	clc
	jmp okdrv

nolba:	mov bx,txt3
	mov ax,dx
	add ax,ax
	and ax,15
	add bx,ax
	mov byte [cs:bx],' '	; zap digit
	clc
	jmp okdrv

nodrv:	mov bx,txt2
	mov ax,dx
	add ax,ax
	and ax,15
	add bx,ax
	mov byte [cs:bx],' '	; zap digit
	mov bx,txt3		; no drive also means no lba
	add bx,ax
	mov byte [cs:bx],' '	; zap digit
	stc

okdrv:	ret

elevel	db 0	; drive count

txt	db "Present harddisks in 0x80..0x87 range:",13,10
txt2	db "0 1 2 3 4 5 6 7 exist",13,10
	db "LBA support for harddisks:",13,10
txt3	db "0 1 2 3 4 5 6 7 have LBA",13,10
	db "$"
